public class OptSuchbaum {


  public static Baum berechnung (int [] p, int [] q) {
      int min;
      int j, argmin, nmax;
      argmin = 0; 
      nmax = p.length-1;
      int [] [] c, r, w;
      c = new int [nmax+1][nmax+1];
      r = new int [nmax+1][nmax+1];
      w = new int [nmax+1][nmax+1];

      // Initialisierung von c und w
 
      for (int i=0; i <= nmax; i++){
        c[i][i] = 0;
      }
      for (int i=0; i <= nmax-1; i++){
        w[i][i] = p[i];
        for(int k =i+1; k <= nmax; k++){ 
          w[i] [k] = w[i][k-1] + q[k] + p[k];
        }
      }

      // Ansatz dynamische Programmierung    

      for (int l = 1; l <= nmax; l++) {
        for (int i = 0; i <= nmax - l; i++) {
          j = i+l;
          min = 2147483647; // groesste int-Zahl
          for (int k = i+1; k <= j; k ++) {
                 if (c[i][k-1]+c[k][j] < min) {
                 min    = c[i][k-1]+c[k][j];
                 argmin = k;
             }
          }
        c[i][j] = w[i][j] + min;
        r[i][j] = argmin;
        }
      }
      return traceBack(0, nmax, r);
  
  }

  // Methode zur Rekonstruktion des Baumes.
  private static Baum traceBack (int i, int j, int [][] r) {
    int k;
    if (i<j) {
      k = r[i][j];
      return new Baum(k ,traceBack(i,k-1,r), traceBack(k,j,r));
    }
    else
      return new Baum();
  }


  public static void main (String [] args) {     
    System.out.println("Anzahl der Eintraege in p:");
    int anz = IO.Eingabe();
    int [] p = new int [anz];
    int [] q = new int [anz];
    for (int i = 0; i < anz; i++){
        System.out.println("p[" + i + "]" + ":");
	p[i] = IO.Eingabe();
    }
 
    
    for (int i = 1; i < anz; i++){
        System.out.println("q[" + i + "]" + ":");
	q[i] = IO.Eingabe();
    }
   
    System.out.println(berechnung(p, q).in_order());  


   }
}
